// This #include statement was automatically added by the Particle IDE.
#include "VL53L0X.h"

/* This example shows how to use continuous mode to take range measurements with the VL53L0X. It is based
on vl53l0x_ContinuousRanging_Example.c from the VL53L0X API.
The range readings are in units of mm. */
#include <Wire.h>
#include <VL53L0X.h>
String eventName =  "NAAM_HIER"; //Vul hier je eigennaam in
VL53L0X sensor;
int distance = -1;
int delayTime = 4000; //pas deze waarde aan om metingen te doen over langere tijden. LET OP!! verander de t in de while loop ook zodat de metingen klaar zijn na de delayTime.

Timer pubTime(delayTime, pubMeasurment);

int t = 0;
int x = 0;
int pi = 0;
int pf = 0;
int pdiff = 0;
int change = 0;


//Calibratie waarden!!!!!!! Pas deze aan als het nodig is.
int LM = 120; //hoogte waarde voor lamiair
int MH = 155; //laagste waarde voor turbulent

void setup()
{
 pubTime.start();
 Serial.begin(9600);
 Wire.begin();
 sensor.init();
 sensor.setTimeout(500);
 // Start continuous back-to-back mode (take readings as
 // fast as possible). To use continuous timed mode
 // instead, provide a desired inter-measurement period in
 // ms (e.g. sensor.startContinuous(100)).
 sensor.startContinuous();
}
void loop()
{
 if (sensor.timeoutOccurred()) { Serial.print(" TIMEOUT"); }
 distance = sensor.readRangeContinuousMillimeters();
}

void pubMeasurment(){
    change = 0;
    t = 0;
    pi = 0;
    pf = 0;
    pdiff = 0;
    while(t <= 40){ //Pas hier de t aan samen. LET OP!!! Verander ook de delayTime boven aan ook, zodat deze goed uitkomen.
        pi = distance;
        delay(100); //Pas dit aan voor meer metingen perseconden.
        pf = distance;
        change = change + abs(pi-pf);
        t++;
    }
    if (change <= LM){
        Serial.print(change);
        Serial.println("   Laminair");
        Particle.publish(eventName, "Laminair");
    }
    else if ( (LM < change) && (change <= MH) ){
        Serial.print(change);
        Serial.println("   Tussen fase");
        Particle.publish(eventName, "Tussen fase");
    }
    else if ( (MH < change) && (change <= 10000) ){
        Serial.print(change);
        Serial.println("   Turbulent");
        Particle.publish(eventName, "Turbulent");
    }
    //Serial.print(change); //Zet deze aan om de actule waarde te krijgen via de serial port. Erg handig voor calibratie.(hang hem dus aan een laptop en lees de usb port uit via de arduino applet).
}
